Bug 633448 - [6.1 FEAT] makedumpfile support - convert Linux on z dumps to ELF - binutils part
[6.1 FEAT] makedumpfile support - convert Linux on z dumps to ELF - binutils ...
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: binutils (Show other bugs)
s390x All
high Severity high
: beta
: 6.1
Assigned To: Andreas Schwab
: FutureFeature, OtherQA
Depends On:
Blocks: 633869 538808 580566
  Show dependency treegraph
Reported: 2010-09-13 15:10 EDT by IBM Bug Proxy
Modified: 2011-05-19 09:41 EDT (History)
9 users (show)

See Also:
Fixed In Version: binutils-
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2011-05-19 09:41:01 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
binutils- (9.27 KB, text/plain)
2010-11-29 11:02 EST, IBM Bug Proxy
no flags Details

External Trackers
Tracker ID Priority Status Summary Last Updated
IBM Linux Technology Center 67046 None None None Never

  None (edit)
Description IBM Bug Proxy 2010-09-13 15:10:58 EDT
1. Feature Overview:
Feature Id: [67046]
a. Name of Feature: [6.1 FEAT] makedumpfile support - convert Linux on z dumps to ELF - binutils part
b. Feature Description
This feature allows to convert s390 format dumps into ELF format dumps. This is needed in order to
be able to use makedumpfile tool. This feature has different parts needed and tracked in different
feature depending on the affected component (kernel, binutils, crash, s390-tools).

The port of makedumfile to s390 is tracked by a different feature.

This concrete feature provides the binutils part:
The already defined PRSTATUS ELF core section contains only general purpose and access registers and
the program status word. There are additional registers like control registers or the TOD register
that should be stored in a separate ELF header. For that purpose new ELF notes in the binutils
(include/elf/common.h) and the corresponding data structures must be defined. 

For using this feature the installation of an updated binutils package is not mandatory, because
only the numbers of the new note sections are defined there and the "readelf" tool (-n option) and
"objdump" tool (-s option) will be updated for printing the the new sections. If a user runs the old
binutils package, the only impact will be that "readelf" will print "unknown" for the new sections.

2. Feature Details:
Sponsor: LTC zSeries BOE
Architectures:   zSeries - 64 native, 

Arch Specificity: purely arch specific code
Affects Kernel Modules: Field does not exist
Delivery Mechanism: Backport
Category: other
Request Type: Toolchain - Enhancement from IBM
d. Upstream Acceptance: Field does not exist
Sponsor Priority P2
f. Severity: high
IBM Confidential: No
Code Contribution: IBM code
g. Component Version Target:---

3. Business Case
The memory footprints of Linux on System z systems grow from year to year and therefore also system
dumps become sometimes so large that it is hard to work with them. For example transferring a 50 GB
dump over the network to a service organization can take a very long time.
The "makedumpfile" open source tool is used to compress system dumps by filtering out memory pages
like free, user space or cache pages that are not necessary for dump analysis.

This feature will improve and remove possible future restrictions in service, by enabling the
infrastructure needed to be able to use makedumfile on Linux on System z. 

4. Primary contact at Red Hat:
John Jarvis jjarvis@redhat.com

5. Primary contacts at Partner:
Project Management Contact:
Hans-Georg Markgraf, mgrf@de.ibm.com

Technical contact(s):
Gonzalo Muelas Serrano, gmuelas@de.ibm.com
Comment 2 John Jarvis 2010-09-21 13:27:40 EDT
Will this be needed even if we do the rebase to binutils requested in BZ 633574 ?
Comment 3 Gonzalo Muelas Serrano 2010-09-22 10:28:03 EDT
The minimum binutils version including this feature is: binutils
So if the rebase asked in Bug 633574 (>=2.21) is done, there is no need for IBM to provide a backport for this feature.

Please let us know if you are rebasing binutils to inform the developers asap not to do the backport (they will start quite soon).

Thank you!
Comment 4 IBM Bug Proxy 2010-10-04 11:17:35 EDT
------- Comment From rsisk@us.ibm.com 2010-10-04 10:36 EDT-------
Code Upstream Status: Accepted
Comment 5 John Jarvis 2010-11-22 13:12:56 EST
There are no plans to rebase binutils in RHEL 6.1, please proceed with
backports for RHBZs 631540, 633377 and 633448.
Comment 7 John Jarvis 2010-11-24 11:43:18 EST
IBM is signed up to test and provide feedback, setting OtherQA.
Comment 8 IBM Bug Proxy 2010-11-29 11:02:49 EST
Created attachment 463523 [details]

------- Comment on attachment From michael.holzheu@de.ibm.com 2010-11-29 10:58 EDT-------

binutils: Add new ELF core dump notes sections for extra s390 registers

For s390 ELF core dumps currently only the PSW, the general purpose registers,
and access registers are stored in the PRSTATUS notes section. For analyzing
s390 kernel problems additional registers are important. In order to be able
to include these registers to kernel ELF core dumps, this patch adds the
following five new note sections:

* NT_S390_TIMER:   S390 timer
* NT_S390_TODCMP:  S390 TOD comparator register
* NT_S390_TODPREG: S390 TOD programmable register
* NT_S390_CTRS:    S390 control registers
* NT_S390_PREFIX:  S390 prefix register
Comment 9 John Jarvis 2010-11-30 14:45:47 EST
This enhancement request was evaluated by the full Red Hat Enterprise Linux 
team for inclusion in a Red Hat Enterprise Linux minor release.   As a 
result of this evaluation, Red Hat has tentatively approved inclusion of 
this feature in the next Red Hat Enterprise Linux Update minor release.   
While it is a goal to include this enhancement in the next minor release 
of Red Hat Enterprise Linux, the enhancement is not yet committed for 
inclusion in the next minor release pending the next phase of actual 
code integration and successful Red Hat and partner testing.
Comment 12 IBM Bug Proxy 2011-04-05 02:31:50 EDT
------- Comment From mgrf@de.ibm.com 2011-04-05 02:20 EDT-------
Verified on r 6.1 snapshots - set to verified   Thanks
Comment 13 Chris Ward 2011-04-06 07:03:14 EDT
~~ Partners and Customers ~~

This bug was included in RHEL 6.1 Beta. Please confirm the status of this request as soon as possible.

If you're having problems accessing 6.1 bits, are delayed in your test execution or find in testing that the request was not addressed adequately, please let us know.

Comment 18 John Jarvis 2011-05-04 09:28:48 EDT
From mail:

Test completed the test for the features impacted by binutils against snap5.
They haven't found any issue with the new binutils and the features work as expected with this new version.

Affected and retested features:
  66878 - RHBZ 631540  z196 exploitation in toolchain - binutils
  67046 - RHBZ 633448  makedumpfile support - convert Linux on z dumps to ELF - binutils part
Comment 19 errata-xmlrpc 2011-05-19 09:41:01 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.